#!/usr/bin/perl

use Pg;

@experimente = ('build', 'pos_lkp', 'neg_lkp', 'delins' );
@epsilons=( 0.5, 0.2, 0.1, 0.05, 0.02, 0.01 );

$conn = Pg::connectdb("host=kt16.theoinf.tu-ilmenau.de dbname=cuckoo-experimente user=weidling password=gl_1984*");

$d_min = 4;
$min_epsilon = 0.05;

$result_verfahren = $conn->exec("select id, name from verfahren where name in ('cuckoo-dary', 'cuckoo-block', 'cuckoo-lp', 'cuckoo-block-improved')");
while( @row_verfahren = $result_verfahren->fetchrow ){
  $id = $row_verfahren[0];
  $fn = $row_verfahren[1];

  foreach $eps (@epsilons){
      open(FILEWRITE, "> $fn-$eps.csv");
      $epsmin = $eps - 0.001;
      $epsmax = $eps + 0.001;
      $sql = "select d, build, pos_lkp, neg_lkp, build_success, delins, delins_success from data where verfahren=$id and epsilon between $epsmin and $epsmax and delins is not null order by d";
#      print "$sql\n";
      $result = $conn->exec($sql);
      while( @row = $result->fetchrow ){
	  for( $i=0; $i < $result->nfields; $i++ ){
	      print FILEWRITE "\t" if( $i > 0 );
	      print FILEWRITE $row[$i]
	  }
	  print FILEWRITE "\n";
      }
      close( FILEWRITE );
  }
  
  
  open(FILEWRITE, "> $fn.csv");

  $result = $conn->exec("select d, epsilon, delins, build, pos_lkp, neg_lkp from data where verfahren=$id and d >= $d_min and epsilon >= $min_epsilon and delins is not null order by d, epsilon");

  $d = $d_min;
  
  while( @row = $result->fetchrow ){
    if( $d != $row[0] ){
      print FILEWRITE "\n";
    }
    $d = $row[0];
    $eps = $row[1];
    $t = $row[2];
    $build = $row[3];
    $pos_lkp = $row[4];
    $neg_lkp = $row[5];
    print FILEWRITE "$d\t$eps\t$t\t$build\t$pos_lkp\t$neg_lkp\n";
  }
  close FILEWRITE;
}
