#!/usr/bin/perl

# Führt mehrere Tests durch
# Die Ergebnisse der Durchläufe werden auf der Standardausgabe ausgegeben,
# Zwischenstände werden im Fehlerstream ausgegeben

use POSIX qw(locale_h);

$executable = "..\/cuckoo";
$verfahren = 1;
$outfile = "cuckoo";

if ( @ARGV  > 0 ) {
    $executable = $ARGV[0];
}

if ( @ARGV  > 1 ) {
    $verfahren = $ARGV[1];
}

if ( @ARGV  > 2 ) {
    $outfile = $ARGV[2];
}

# @epsilons = (0.5, 0.1, 0.05, 0.02, 0.01, 0.005, 0.002, 0.001, 0.0005, 0.0002, 0.0001);
@epsilons = (0.5, 0.2, 0.1, 0.05, 0.02, 0.01 );

foreach $epsilon(@epsilons){
	$fn = "$outfile-$epsilon.csv";
	$cmd = "perl time-d.pl $executable $verfahren $epsilon 32 5 1>$fn 2>\/dev\/null";
	$res = qx/$cmd/;
}
