#!/usr/bin/perl

# Fhrt mehrere Tests durch
# Die Ergebnisse der Durchlufe werden auf der Standardausgabe ausgegeben,
# Zwischenstnde werden im Fehlerstream ausgegeben

use POSIX qw(locale_h);

#@epsilons = (0.5, 0.2, 0.1, 0.05, 0.02, 0.01 );
# @ds = (2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32);
@ds = (2..32);

$nkeys = 1000000;

%names = ( 
	   0=>"cuckoo-block", 
	   1=>"cuckoo-lp",
	   3=>"cuckoo-simple",
	   4=>"cuckoo-dary",
	   );


while( ($id,$name)=each(%names) ){
	foreach $d(@ds){
	$fn = "$name-$d.csv";
	open( IN, $fn );
	while ($line = <IN>) {
		$line =~ /(.+)\t(.+)\t(.+)\t(.+)\t(.+)\t(.+)\t(.+)/gi;
		for( $i=1; $i <= 7; $i++ ){
			$a[$i] = ${$i};
			if( $a[$i] eq "-" ){ $a[$i] = "NULL"; }
		}
		$sql = "insert into data ( verfahren, nkeys, d, " .
			"epsilon, build, pos_lkp, neg_lkp, build_success, delins, " .
			"delins_success) values ($id, $nkeys, $d, $a[1], " .
			"$a[2], $a[3], $a[4], $a[5], $a[6], $a[7] )";
		print "$sql;\n";
	}
    }
}

$id = 2;
$fn = "lp.csv";
open( IN, $fn );
while ($line = <IN>) {
    $line =~ /(.+)\t(.+)\t(.+)\t(.+)\t(.+)\t(.+)\t(.+)/gi;
    for( $i=1; $i <= 7; $i++ ){
	$a[$i] = ${$i};
	if( $a[$i] eq "-" ){ $a[$i] = "NULL"; }
    }
    $sql = "insert into data ( verfahren, nkeys, d, " .
	"epsilon, build, pos_lkp, neg_lkp, build_success, delins, " .
	"delins_success) values ($id, $nkeys, NULL, $a[1], " .
	"$a[2], $a[3], $a[4], $a[5], $a[6], $a[7] )";
    print "$sql;\n";
}
